> For the complete documentation index, see [llms.txt](https://docs.zkopru.network/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.zkopru.network/arctic-roll/how-it-works/utxo.md).

# UTXO

UTXOs include the following properties.

| Property                 | Description                                                                                 |
| ------------------------ | ------------------------------------------------------------------------------------------- |
| Ether                    | The amount of ETH                                                                           |
| Public Key               | A Babyjubjub point of the note owner                                                        |
| Salt                     | Random salt. Zkopru generates UTXO hash using this salt.                                    |
| Token Address (Optional) | The address of the token contract when it includes ERC20 or ERC721. The default value is 0. |
| ERC20 Amount (Optional)  | The amount of the ERC20 token when it includes ERC20. The default value is 0.               |
| NFT Id (Optional)        | The id of the ERC721 token when it includes ERC721. The default value is 0.                 |

And then Zkopru computes the leaf hash with Poseidon hash:

```javascript
var intermediate_hash = poseidon(ether, pub_key.x, pub_key.y, salt)
var result_hash = poseidon(intemediate_hash, token_address, erc20, nft)
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.zkopru.network/arctic-roll/how-it-works/utxo.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
